freeslot(
	"S_FIRSHEN",
	"SPR_FSHN",
	"MT_FIRFIRSHEN",
	"S_FLARBAR",
	"SPR_FFLM",
	"MT_FIRFLARBAR",
	"SPR2_CHFL",
	"S_PLAY_CHFL",
	"S_PLAY_FCROLL",
	"S_FLMCHARGSHIELD",
	"MT_FLMCHARGSHIELD",
	"MT_FIRTRAIL"
)


states[S_FLARBAR] = {
	sprite = SPR_FFLM,
	frame = A,
	tics = -1
}

states[S_FIRSHEN] = {
	sprite = SPR_FSHN,
	frame = A,
	tics = -1
}

states[S_PLAY_CHFL] = {
	sprite = SPR_PLAY,
	frame = SPR2_CHFL,
	tics = 4,
	nextstate = S_PLAY_STND
}

states[S_PLAY_FCROLL] = {
	sprite = SPR_PLAY,
	frame = FF_ANIMATE|SPR2_ROLL,
	tics = 8,
	var1 = 4,
	var2 = 2,
	nextstate = S_PLAY_SPRING
}

states[S_FLMCHARGSHIELD] = {
	sprite = SPR_FIRS,
	frame = S,
	tics = -1
}

mobjinfo[MT_FIRFIRSHEN] = {
	spawnstate = S_FIRSHEN,
	spawnhealth = 1,
	seesound = sfx_s3k47,
	deathstate = S_SMOKE1,
	deathsound = sfx_s3k4f,
	speed = 40*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_FIRFLARBAR] = {
	spawnstate = S_FLARBAR,
	spawnhealth = 1,
	seesound = sfx_s3kc2s,
	deathstate = S_SMOKE1,
	speed = 10*FRACUNIT,
	radius = 10*FRACUNIT,
	height = 23*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_FLMCHARGSHIELD] = {
	spawnstate = S_FLMCHARGSHIELD,
	radius = 33*FRACUNIT,
	height = 65*FRACUNIT,
	damage = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_FIRTRAIL] = {
	spawnstate = S_SPINFIRE1,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	damage = 1,
	flags = MF_FIRE|MF_STICKY|MF_SCENERY
}